#version 330

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;
// variante 1
uniform mat4 lightSpaceMatrix;
out vec4 FragPosLightSpace;
//uniform vec3 lightPosition_worldspace;

//variante 2
uniform mat4 depthMVP;
uniform mat4 DepthBiasMVP; 

out vec4 ShadowCoord;

in vec3 position;
in vec3 normals;
in vec2 uv;

out vec2 UVs;
out vec3 position_worldspace;
out vec3 normal_cameraspace;
out vec3 eyeDirection_cameraspace;
out vec3 varyingNormalDirection; 

// for lighting


void main()
{
	
	
	// Output position of the vertex, in clip space : MVP * position
	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position, 1);
	
	position_worldspace = (modelMatrix * vec4(position,1)).xyz;
	normal_cameraspace = (viewMatrix * modelMatrix * vec4(normals, 0)).xyz;
	vec3 position_cameraspace = ( viewMatrix * modelMatrix * vec4(position,1)).xyz;
	eyeDirection_cameraspace = vec3(0,0,0) - position_cameraspace;
	
	/* Transform normal vectors with transpose of inverse of upper left
     3x3 model matrix (ex-gl_NormalMatrix): */
	mat3 m_3x3_inv_transp = transpose(inverse(mat3(modelMatrix)));
	//varyingNormalDirection = normalize(m_3x3_inv_transp * position);
	varyingNormalDirection = (modelMatrix * vec4(normals, 0.0)).xyz; //TODO
	// variante 1
	//FragPosLightSpace = lightSpaceMatrix * vec4(position, 1); 
	
	// variante 2
	UVs = uv;
	ShadowCoord = DepthBiasMVP *  vec4(position_worldspace, 1);
	//ShadowCoord = lightSpaceMatrix * vec4(position, 1); 
	//vec3 LightPosition_cameraspace = ( viewMatrix * vec4(lightPosition_worldspace,1)).xyz;
	// Vector that goes from the vertex to the light, in camera space. M is ommited because it's identity.
	//lightDirection_cameraspace = LightPosition_cameraspace + eyeDirection_cameraspace;

}
